% choix_base parametre qui permet de choisir le type de base de donnees
choix_base=1;
%
% length_vec_boucle est la taille du vecteur contenant les differentes
% valeurs du nombre de boucles
length_vec_nb_iter=100;
%
% variables locales
%
vec_nb_iter=unique(round(10.^linspace(0,6,length_vec_nb_iter)));
length_vec_nb_iter=length(vec_nb_iter);
%
% vec_taux sont les matrices qui contiennent les taux de classification
M=1;m=1;
vec_taux_app_Hebb=zeros(length_vec_nb_iter,M);
vec_taux_gen_Hebb=zeros(length_vec_nb_iter,M);
vec_taux_app_PI=zeros(length_vec_nb_iter,M);
vec_taux_gen_PI=zeros(length_vec_nb_iter,M);
vec_taux_app_gradient=zeros(length_vec_nb_iter,M);
vec_taux_gen_gradient=zeros(length_vec_nb_iter,M);
%
% w_vrai est le vecteur frontiere de la base d'apprentissage lineairement
% separable
w_vrai=randn(N,1);
%
for ind_nb_iter=length(vec_nb_iter):-1:1
    %
    nb_iter=vec_nb_iter(ind_nb_iter);
    %
    % generation de la base d'apprentissage et la base de gen
    %
    if ind_nb_iter==length(vec_nb_iter)
        [Xapp,dapp,Xgen,dgen]=genere_base_lineairement_separable(w_vrai,Papp,Pgen);
        %
        % Hebb
        %
        % apprentissage
        %
        w=discriminateur_Hebb(Xapp,dapp);
        %
        % calcul des taux d'erreur
        %
        taux_app_Hebb=calcul_taux(Xapp,dapp,w);
        taux_gen_Hebb=calcul_taux(Xgen,dgen,w);
        %
        % Pseudo-inverse
        %
        % apprentissage
        %
        w=discriminateur_PI(Xapp,dapp);
        %
        % calcul des taux d'erreur
        %
        taux_app_PI=calcul_taux(Xapp,dapp,w);
        taux_gen_PI=calcul_taux(Xgen,dgen,w);
        %
        % gradient
        %
        % apprentissage
        %
        choix_waitbar=1;
        [~,~,mat_w]=discriminateur_gradient(Xapp,dapp,nb_iter,lambda,choix_waitbar);
    end
    %
    % Hebb
    vec_taux_app_Hebb(ind_nb_iter,m)=taux_app_Hebb;
    vec_taux_gen_Hebb(ind_nb_iter,m)=taux_gen_Hebb;
    %
    % PI
    vec_taux_app_PI(ind_nb_iter,m)=taux_app_PI;
    vec_taux_gen_PI(ind_nb_iter,m)=taux_gen_PI;
    %
    % calcul des taux d'erreur en fonction du nombre d'itrations
    %
    w=mat_w(:,ind_nb_iter);
    taux_app=calcul_taux(Xapp,dapp,w);
    taux_gen=calcul_taux(Xgen,dgen,w);
    %
    vec_taux_app_gradient(ind_nb_iter,m)=taux_app;
    vec_taux_gen_gradient(ind_nb_iter,m)=taux_gen;
    %
end
%
% calcul et plot des taux moyen
%
figure
cell_couleur={'b','r','c'};
h=zeros(3,1);
for methode=1:3
    %
    couleur=cell_couleur{methode};
    %
    if methode==1
        vec_taux_app=vec_taux_app_Hebb;
        vec_taux_gen=vec_taux_gen_Hebb;
    elseif methode==2
        vec_taux_app=vec_taux_app_PI;
        vec_taux_gen=vec_taux_gen_PI;
    elseif methode==3
        vec_taux_app=vec_taux_app_gradient;
        vec_taux_gen=vec_taux_gen_gradient;
    end
    % base d'apprentissage
    vec_mean_taux_app=mean(vec_taux_app,2);
    %
    % base de gen
    vec_mean_taux_gen=mean(vec_taux_gen,2);
    %
    % plot
    subplot(2,1,1)
    h(methode)=semilogx(vec_nb_iter,vec_mean_taux_app,couleur);
    %
    if methode==1
        hold on
        title(['P_{app} = ' num2str(Papp)  ...
            ', lambda = ' num2str(lambda)])
    end
    %
    subplot(2,1,2)
    h(methode+3)=semilogx(vec_nb_iter,vec_mean_taux_gen,couleur);
    %
    if methode==1
        hold on
        title(['P_{gen} = ' num2str(Pgen)])
    end
end
%
set(h,'linewidth',2)
for m=1:2
    subplot(2,1,m)
    if m==1
        ylabel('\tau_{app}')
    else
        ylabel('\tau_g')
    end
    grid on
    xlabel('nb d''iterations du gradient')
    %
    if m==1
        set(gca,'ylim',[0.7 1.1])
    else
        set(gca,'ylim',[0.4 0.9])
    end
    %
    set(gca,'fontsize',14);
    L=legend('Hebb','PI','gradient');
    set(L,'Location','northeast')
end
