%
vec_Papp=2:200;
vec_taux_app_Hebb=nan(size(vec_Papp));
vec_taux_app_PI=nan(size(vec_Papp));
%
vec_taux_gen_Hebb=nan(size(vec_Papp));
vec_taux_gen_PI=nan(size(vec_Papp));
%
if choix_RA_et_gradient==1
    vec_taux_app_RA=nan(size(vec_Papp));
    vec_taux_app_grad=nan(size(vec_Papp));
    vec_taux_gen_RA=nan(size(vec_Papp));
    vec_taux_gen_grad=nan(size(vec_Papp));
end
%
% generation d'une frontiere aleatoire
w_vrai=randn(N,1);
%
h_bar = waitbar(0,'Please wait...');
%
for ind_Papp=1:length(vec_Papp)
    %
    waitbar(ind_Papp/length(vec_Papp),h_bar)
    %
    Papp=vec_Papp(ind_Papp);
    %
    % generation de la base d'apprentissage
    [Xapp,dapp]=genere_base_lineairement_separable(w_vrai,Papp);
    %
    % estimation de la frontiere w
    w_Hebb=discriminateur_Hebb(Xapp,dapp);
    w_PI=discriminateur_PI(Xapp,dapp);
    %
    if choix_RA_et_gradient==1
        if strcmp(sigma,'?')
            w_RA=randn(size(w_PI));
        else
            w_RA=discriminateur_RA(Xapp,dapp,sigma);
        end
        choix_waitbar=0;
        w_grad=discriminateur_gradient(Xapp,dapp,nb_iter,lambda,choix_waitbar);
    end
    %
    % calcul du taux de reussite sur la base d'apprentissage
    %
    d_est=sign(real(Xapp'*w_Hebb));
    vec_taux_app_Hebb(ind_Papp)=mean(d_est==dapp);
    %
    d_est=sign(real(Xapp'*w_PI));
    vec_taux_app_PI(ind_Papp)=mean(d_est==dapp);
    %
    if choix_RA_et_gradient==1
        d_est=sign(real(Xapp'*w_RA));
        vec_taux_app_RA(ind_Papp)=mean(d_est==dapp);
        %
        d_est=sign(real(Xapp'*w_grad));
        vec_taux_app_grad(ind_Papp)=mean(d_est==dapp);
    end
    %
    % calcul du taux de generalisation 
    %
    if (ind_Papp==1)||(choix_nouvelle_base_gen==1)
        [~,~,Xgen,dgen]=genere_base_lineairement_separable(w_vrai,0,Pgen);
    end
    %
    d_est=sign(real(Xgen'*w_Hebb));
    vec_taux_gen_Hebb(ind_Papp)=mean(d_est==dgen);
    %
    d_est=sign(real(Xgen'*w_PI));
    vec_taux_gen_PI(ind_Papp)=mean(d_est==dgen);
    %
    if choix_RA_et_gradient==1
        d_est=sign(real(Xgen'*w_RA));
        vec_taux_gen_RA(ind_Papp)=mean(d_est==dgen);
        %
        d_est=sign(real(Xgen'*w_grad));
        vec_taux_gen_grad(ind_Papp)=mean(d_est==dgen);
    end
end
close(h_bar)
%
figure
subplot(2,1,1)
plot(vec_Papp,vec_taux_app_Hebb,'bx')
hold on
plot(vec_Papp,vec_taux_app_PI,'ro')
grid on
if choix_RA_et_gradient==1
    plot(vec_Papp,vec_taux_app_RA,'g+')
    plot(vec_Papp,vec_taux_app_grad,'cs')
end
set(gca,'ylim',[0.8 1])
xlabel('P_{app}')
ylabel('\tau_{app}')
title('taux de reussite obtenu sur la base d''apprentissage')
if choix_RA_et_gradient==1
    L=legend('Hebb','PI','RA','gradient');
else
    L=legend('Hebb','PI');
end
set(L,'location','southeast')
set(gca,'fontsize',14);

subplot(2,1,2)
plot(vec_Papp,vec_taux_gen_Hebb,'bx')
hold on
plot(vec_Papp,vec_taux_gen_PI,'ro')
grid on
if choix_RA_et_gradient==1
    plot(vec_Papp,vec_taux_gen_RA,'g+')
    plot(vec_Papp,vec_taux_gen_grad,'cs')
end
title(['taux de reussite obtenu sur la base de generalisation' ...
    ', P_{gen} = ' num2str(Pgen)])
set(gca,'ylim',[0.2 1])
xlabel('P_{app}')
ylabel('\tau_{g}')
if choix_RA_et_gradient==1
    L=legend('Hebb','PI','RA','gradient');
else
    L=legend('Hebb','PI');
end
set(L,'location','southeast')
set(gca,'fontsize',14);
