function [w,vec_J,mat_w]=discriminateur_gradient(X,d,nb_boucle,lambda,choix_waitbar)
%
% [w,vec_J]=discriminateur_gradient(X,d,nb_boucle,lambda,choix_waitbar);
%
% entrees
%========
% X : matrice de taille NxP contenant P vecteur
% d : vecteur colonne de taille P
% nb_boucle : nombre d'iterations dans le gradient
% lambda : pas du gradient
%
% sorties
%========
% w : vecteur colonne de taille N
% vec_J : valeur du critere
%
if nargin<=2
    nb_boucle=0;
end
if nargin<=3
    lambda=0.01;
end
if nargin<=4
    choix_waitbar=0;
end
%
N=size(X,1);
%
% initialisation
w=zeros(N,1);
if nargout>=2
    vec_J=zeros(1,nb_boucle);
end
if nargout>=3
    mat_w=zeros(N,nb_boucle);
end
%
if choix_waitbar==1
    h_bar = waitbar(0,'Please wait...');
end
%
for n=1:nb_boucle
    %
    if choix_waitbar==1
        nn=(n-1)/nb_boucle*100;
        if nn==floor(nn)
            waitbar(n/nb_boucle,h_bar)
        end
    end
    %
    % calcul du gradient
    grad=-2*X*(X'*w-d);
    %
    w=w+lambda*grad;
    %
    if nargout>=3
        mat_w(:,n)=w;
    end
    if nargout>=2
        vec_J(n)=(d-X'*w)'*(d-X'*w);
    end
end
if choix_waitbar==1
    close(h_bar)
end
end