function [X,d]=genere_base_de_donnees(P,cell_mu,cell_Gamma)
%
% [X,d]=genere_base_de_donnees(P,cell_mu,cell_Gamma);
%
% entrees
%========
% P est est le nombre d'elements de la base pour chacune des classes
% cell_mu est une cellule de qui contient les vecteurs de moyenne
% cell_Gamma est une cellule de qui contient les differentes matrice de covariance
%
% sorties
%========
% X est une matrice de taille NxP qui contient les differents vecteurs de
% la base
% d est un vecteur de taille P 
%

N=length(cell_mu{1});
nb_classe=length(cell_Gamma);
PP=ceil(P/nb_classe);
%
% on initialise eventuellement plus grand
%
X=zeros(N,PP*nb_classe);
d=zeros(PP*nb_classe,1);
%
for c=1:nb_classe
    mu=cell_mu{c};
    Gamma=cell_Gamma{c};
    ind=(c-1)*PP+(1:PP);
    %
    d(ind)=c;
    if isreal(Gamma)
        X(:,ind)=mu*ones(1,PP)+sqrtm(Gamma)*randn(N,PP);
    else
        X(:,ind)=mu*ones(1,PP)+sqrt(0.5)*sqrtm(Gamma)*(randn(N,PP)+1i*randn(N,PP));
    end
end
%
% et on enleve le surplus
%
X=X(:,1:P);
d=d(1:P);
%
ind=randperm(length(d));
d=d(ind);
X=X(:,ind);
%
% on met les exemples dans un ordre aleatoire
%
ind=randperm(length(d));
d=d(ind);
X=X(:,ind);
%
end
