function [Xapp,dapp,Xgen,dgen]=genere_base_lineairement_separable(w,Papp,Pgen)
%
% [Xapp,dapp,Xgen,dgen]=genere_base_lineairement_separable(w,Papp,Pgen);
%
% entrees
%========
% w : vecteur colonne qui caracterise la frontiere
% Papp : taille de la base d'apprentissage
% Pgen : taille de la base de gen
%
% sorties
%========
% Xapp : matrice de taille NxPapp 
% dapp : vecteur colonne de taille Papp
% Xgen : matrice de taille NxPgen 
% dgen : vecteur colonne de taille Pgen


N=length(w);
%
% generation de Papp vecteur aleatoires
M=diag([ones(N-1,1);0.5]);
Xapp=M*randn(N,Papp);
%
% calcul de la classe de ces vecteurs
dapp=sign(w'*Xapp);
dapp=dapp(:);
%
if nargout==2
    return
end
%
% generation de Papp vecteur aleatoires
Xgen=M*randn(N,Pgen);
%
% calcul de la classe de ces vecteurs
dgen=sign(w'*Xgen);
dgen=dgen(:);
%
end