%
% N est la dimension de l'espace des mesures
N=2;
%
% generation de la base d'apprentissage
%
if choix_base==1
    % generation d'une frontiere aleatoire
    w_vrai=randn(N,1);
    [Xapp,dapp]=genere_base_lineairement_separable(w_vrai,Papp);
elseif choix_base==2
    mu=randn(2,1);
    cell_mu={mu,-mu};
    cell_Gamma={eye(2),eye(2)};
    [Xapp,dapp]=genere_base_de_donnees(Papp,cell_mu,cell_Gamma);
    dapp(dapp==2)=-1;
elseif choix_base==3
    [Xapp,dapp]=genere_base_non_lineairement_separable(N,Papp);
end
%
% representation de la base d'apprentissage
figure
plot_base_de_donnee(Xapp,dapp)
xlim=get(gca,'xlim');
ylim=get(gca,'ylim');
%
if exist('w_vrai','var')
    % representation de la frontiere vrai (en noir)
    w=w_vrai;
    %
    h=plot(xlim,polyval([-w(1)/w(2) 0],xlim),'k');
    set(h,'linewidth',2)
end
%
% representation de la frontiere estimee par la methode de Hebb (en rouge)
w_hebb=discriminateur_Hebb(Xapp,dapp);
w=w_hebb;
h=plot(xlim,polyval([-w(1)/w(2) 0],xlim),'r--');
set(h,'linewidth',2)
%
% representation de la frontiere estimee par la methode Pseudo-inverse (en vert)
w_PI=discriminateur_PI(Xapp,dapp);
w=w_PI;
h=plot(xlim,polyval([-w(1)/w(2) 0],xlim),'g--');
set(h,'linewidth',2)
%
% mise en forme du graphique
grid on
set(gca,'xlim',xlim);
set(gca,'ylim',ylim);
if exist('w_vrai','var')
    legend('classe 1','classe 2','w vrai','w Hebb','w PI')
else
    legend('classe 1','classe 2','w Hebb','w PI')
end
title([num2str(Papp) ' vecteurs de la base d''apprentissage'])